--=============================================================================
-- File:		DKP_System_GUI.lua
-- Author:	Sammysnake of Ner'Zhul	 2004, 2005 Syndicate Systems
-- Description:	GUI Functions for the DKP_System Addon
--
-- Created: July, 17, 2005
-- Modified: July, 19, 2005
--=============================================================================

-- ############################################################################################
-- ## Interface Functions 

------------------------
-- General GUI Functions

function DKP_System_GUI_Refresh()
	local currentID = UIDropDownMenu_GetSelectedID(AuctionModeDropDown);
end

function DKP_System_GUI_ToggleVisibility()
	if( not DKPSystemFrame_GUI:IsVisible() )then
			DKPSystemFrame_GUI:Show();
			DKP_ROLL_Config.GUIOpen = true;
	else
			DKPSystemFrame_GUI:Hide();
			DKP_ROLL_Config.GUIOpen = false;
	end
end

function DKP_System_GUI_Hide()
	if( DKPSystemFrame_GUI:IsVisible() )then
		DKPSystemFrame_GUI:Hide();
	end
end

function DKP_System_GUI_OnDragStart()		
	
	DKPSystemFrame_GUI:StartMoving();
	--bBeingDragged = true;	
	
end


function DKP_System_GUI_OnDragStop()
	
	DKPSystemFrame_GUI:StopMovingOrSizing();
	--bBeingDragged = false;
	
end

function DKP_System_GUI_OnUpdate(arg1)

end

function DKP_System_GUI_OnEvent()

end

-------------------------------
-- Item Widget Pulldown 


function DKPSystem_GUI_Items_OnLoad()
	UIDropDownMenu_Initialize(this, DKPSystem_GUI_Items_LoadNames);			
	UIDropDownMenu_SetWidth(110);
	
end

ITEMS_DROPDOWN_LIST = {
		{ name = "No Items", linktext = "No Item Selected" }
};


function DKPSystem_GUI_Items_LoadNames()

	local info;

	for i = 1, getn(ITEMS_DROPDOWN_LIST), 1 do
		info = { };
		info.text = ITEMS_DROPDOWN_LIST[i].name;
		info.func = DKPSystem_GUI_Items_OnClick;
		UIDropDownMenu_AddButton(info);
	end
	
	UIDropDownMenu_SetText("Select Item", DKPSystem_GUI_ItemSelectDropDown);
	
	--local defaultName =  UIDropDownMenu_GetText(DKPSystem_GUI_Items_LoadNames);
	--UIDropDownMenu_SetSelectedValue(DKPSystem_GUI_Items_LoadNames, defaultName);	
	
	--local oldID = UIDropDownMenu_GetSelectedID(DKPSystem_GUI_ItemSelectDropDown);
	UIDropDownMenu_SetSelectedID(DKPSystem_GUI_ItemSelectDropDown, 1);
			
end

function DKPSystem_GUI_Items_OnClick()
		
	local oldID = UIDropDownMenu_GetSelectedID(DKPSystem_GUI_ItemSelectDropDown);
	local newID = this:GetID();
	
	UIDropDownMenu_SetSelectedID(DKPSystem_GUI_ItemSelectDropDown, this:GetID());
	if(oldID ~= this:GetID()) then
		--Atlas_Refresh();
		--DEFAULT_CHAT_FRAME:AddMessage(this:GetID());
		--DKP_ROLL_Config.System = AUCTION_MODES_DROPDOWN_LIST[newID].value;		
	end	
	
end


-------------------------------
-- Auction Mode Widget Pulldown 


function AuctionModeDropDown_OnLoad()
	UIDropDownMenu_Initialize(this, AuctionMode_LoadNames);			
	UIDropDownMenu_SetWidth(110);
	
end

AUCTION_MODES_DROPDOWN_LIST = {
		{name="Open Auction", value="OPEN", shortname="Open"},
		{name="Closed Auction", value="CLOSED", shortname="Closed"},
		{name="Roll Auction", value="ROLL", shortname="Roll"}
};

function AuctionMode_LoadNames()

	local info;

	for i = 1, getn(AUCTION_MODES_DROPDOWN_LIST), 1 do
		info = { };
		info.text = AUCTION_MODES_DROPDOWN_LIST[i].name;
		info.func = AuctionModeDropDown_OnClick;
		UIDropDownMenu_AddButton(info);
	end
			
end

function AuctionModeDropDown_OnClick()
		
	local oldID = UIDropDownMenu_GetSelectedID(AuctionModeDropDown);
	local newID = this:GetID();
	UIDropDownMenu_SetSelectedID(AuctionModeDropDown, this:GetID());
	if(oldID ~= this:GetID()) then
		--Atlas_Refresh();
		--DEFAULT_CHAT_FRAME:AddMessage(this:GetID());
		DKP_ROLL_Config.System = AUCTION_MODES_DROPDOWN_LIST[newID].value;
		AuctionOptionsButton:SetText(AUCTION_MODES_DROPDOWN_LIST[newID].shortname .. " Options");
	end	
	
end

function AuctionModeDropDown_OnVariableLoaded() 

	for i = 1, getn(AUCTION_MODES_DROPDOWN_LIST), 1 do
			if (AUCTION_MODES_DROPDOWN_LIST[i].value == DKP_ROLL_Config.System) then
					UIDropDownMenu_SetSelectedID(AuctionModeDropDown, i);
					UIDropDownMenu_SetText(AUCTION_MODES_DROPDOWN_LIST[i].name, AuctionModeDropDown);
					AuctionOptionsButton:SetText(AUCTION_MODES_DROPDOWN_LIST[i].shortname .. " Options");
			end
	end
		
end

-------------------------
-- Auction Options

function DKPSystemOptions_Toggle ()
		
		if (DKP_ROLL_Config.System == "ROLL") then
				DKPSystemRollOptions_Toggle();
		elseif (DKP_ROLL_Config.System == "OPEN") then
				DKPSystemOpenOptions_Toggle();
		elseif (DKP_ROLL_Config.System == "CLOSED") then
				DKPSystemClosedOptions_Toggle();
		end

end